# python /home/rafael/Dropbox/workspace/code/202109_stag_interp_v5/classic_ML_use_Cf_Nu_search/source/genetic_algorithm.py   Cf_classic cuda:1
# python C:\Users\rafae\Dropbox\workspace\code\202109_stag_interp_v5\classic_ML_use_Cf_Nu_search\source\genetic_algorithm.py Cf_classic cuda Phase_1
# ------------------------------------------------------------------------
#                  Basic Libraries
# ------------------------------------------------------------------------
import  socket
from    copy        import  deepcopy
from    os          import  system  as  os_system
from    os          import  listdir as  os_listdir
from    os          import  mkdir   as  os_mkdir
from    os.path     import  join    as  pjoin
from    os.path     import  dirname, basename, abspath, isfile, isdir
from    sys         import  argv
from    sys         import  platform as sys_platform
from    datetime    import  datetime
from    collections import  Counter
# from  pprint   import  pformat 

import  random
                  
SEED = int(datetime.now().strftime("%Y%m%d%H%M%S"))
print(f'RANDOM.SEED = {SEED}\n')

random.seed(SEED)

# ------------------------------------------------------------------------
#                  Basic Functions
# ------------------------------------------------------------------------
# apply_pformat  =  lambda D: pformat(D, sort_dicts=False, indent = 2)
lmap           =  lambda f,x: list(map(f,x))
lfilter        =  lambda f,x: list(filter(f,x))

data_folder         =  pjoin(dirname(dirname(abspath(__file__))),'data')
listdir_full        =  lambda x: sorted([pjoin(x,y) for y in os_listdir(x)])
listdir_full_files  =  lambda x: lfilter(isfile,listdir_full(x))

def deepdirname(x, n, tag=None):
    for _ in range(n):
        x = dirname(x)
    if not (tag is None):
        assert tag in basename(x)
    return x

get_folder_user   =  lambda tag = 'rafae'   : deepdirname(abspath(__file__), 7, tag)
get_folder_cloud  =  lambda tag = 'Dropbox' : deepdirname(abspath(__file__), 6, tag)

def reader(fname):
    with open(fname,'r') as f:
        return [x.rstrip('\n') for x in f]

def fmt_str(seq):
    fmt_one = lambda x: str(x) if type(x)==int else f'{x[0]}x{x[1]}'
    return '_'.join(map(fmt_one,seq))

import_json  =  lambda fname: eval(' '.join(reader(fname)))

own_code     = lambda: reader(abspath(__file__))
initial_code = own_code() 

own_host     = socket.gethostname()
tag_reclvl   = 'reclvl_'

# ------------------------------------------------------------------------
#                  Scan Folder
# ------------------------------------------------------------------------
starting_archs = lambda C = 20: [{'Cseq': [1,          #        SepConv2d( 1, C, 3,   1    )
                                           C,          #        SepConv2d( C, C, 3, ( 2,1) )
                                           C,          #        SepConv2d( C, C, 3, ( 4,2) )
                                           C,          #        SepConv2d( C, C, 3, ( 4,2) )
                                           C,          #        SepConv2d( C, C, 3, ( 8,4) )
                                           C,          #        SepConv2d( C, C, 3, ( 8,4) )
                                           C,          #        SepConv2d( C, C, 3, (16,8) )
                                           C,          #  Conv2d_Circular( C, 1, 3, (16,8)   , bias = False)
                                           1],         
                                   'dseq': [  1   ,    #        SepConv2d( 1, C, 3,   1    )
                                           ( 2,1),     #        SepConv2d( C, C, 3, ( 2,1) )
                                           ( 4,2),     #        SepConv2d( C, C, 3, ( 4,2) )
                                           ( 4,2),     #        SepConv2d( C, C, 3, ( 4,2) )
                                           ( 8,4),     #        SepConv2d( C, C, 3, ( 8,4) )
                                           ( 8,4),     #        SepConv2d( C, C, 3, ( 8,4) )
                                           (16,8),     #        SepConv2d( C, C, 3, (16,8) )
                                           (16,8)]},   #   Conv2d_Circular( C, 1, 3, (16,8)   , bias = False)
                                  {'Cseq': [1, 20, 20, 20, 20, 20, 20, 20, 20, 1],
                                   'dseq': [[1, 1], [2, 1], [4, 2], [4, 2], [8, 4], [8, 4], [16, 8], [16, 8], [16, 8]]},
                                {'Cseq': [1, 20, 20, 20, 20, 20, 20, 20, 1], 'dseq': [[1, 1], [2, 1], [4, 2], [4, 2], [8, 4], [16, 8], [32, 16], [32, 16]]},
                                {'Cseq': [1, 20, 20, 20, 20, 20, 20, 20, 1], 'dseq': [[1, 1], [2, 1], [4, 2], [4, 2], [8, 4], [16, 8], [16, 8], [32, 16]]},
                                ]

                                                

class Scan_Folder:
    def __init__(self, mode, qmode, epochs_avg = 0, metric_names = None, use_dsets = ['test','valid']):
        self.mode         =  mode
        self.epochs_avg   =  epochs_avg
        self.metric_names =  metric_names
        self.use_dsets    =  use_dsets
        
        subfolder  =  {'ini': f'started_{qmode}',
                       'end': f'archive_{qmode}'}[mode]
        if not isdir(pjoin(data_folder,subfolder)):
            os_mkdir(pjoin(data_folder,subfolder))
        
        self.A     =  []
        for  dat_fname  in  lfilter(lambda x: '.dat' in x                            ,
                                    listdir_full_files(pjoin(data_folder,subfolder))):
            self.A.append(self.__mk_entry(dat_fname))
        
                       
                                                                
                                    
                                                                            
                                                                                     
        
        self.A.sort(key= lambda x: x[0])
        line = '------------------------------------'
        print(f'{line}\n        Scanned at folder: {subfolder}\n{line}')
        for i,x in enumerate(self.A):
            print(f'{i:03d}): (error = {x[0]}) (arch = {x[1]}) (info = {x[3]})')
        
    def __mk_entry(self, dat_fname):
        mconv = lambda x: x.replace('_','/').replace('absdiff','|diff|').replace('abstotal','|total|')
        D     = import_json(dat_fname)
        
        arch  = D['ml_runner_info']['args']['args_net']
        error = 0.
        info  = {dset: {} for dset in self.use_dsets}
        fget  = lambda A: sum(list(A))/len(A)
        if self.epochs_avg:
            n_use = self.epochs_avg//D['ml_runner_info']['args']['epoch_report']
            for metric_name,weight in self.metric_names:
                all_val = []
                for dset in self.use_dsets:
                    #new_val  = [abs(val) for val in lmap(lambda d: d[mconv(metric_name)],
                    #                                     D['last_stats'][dset][-n_use:])]
                                                                                                      
                    all_i_use = list(range(-n_use,0,1))
                    new_val  = [abs(D['last_stats'][dset][i_use][mconv(metric_name)]) for i_use in all_i_use]
                    
                    info[dset][metric_name]  = fget(new_val)
                    all_val += new_val
                
                e      =  fget(all_val)
                error +=  e*weight(e)
        info['fname_log'] = D['ml_runner_info']['fname_log']
        if self.mode == 'end':
            info['running_time'], = [x for x in D['ml_runner_info']['log_run_data'] if 'Finished Training' in x]
            assert info['running_time'].count('=') == 1
            h,m,s = lmap(int,info['running_time'].split('=')[1].split('[')[0].split(':'))
            info['running_time'] = 3600*h + 60*m + s
        return error,eval(fmt_arch(arch)),D,info
    
    all_archs     = lambda self: [x[1] for x in self.A]
    get_best_arch = lambda self: (self.all_archs() or starting_archs())[0]
    get_avg_running_time = lambda self: f"{(sum(x[3]['running_time'] for x in self.A)/len(self.A)/3600.):.2f} hours"

# ------------------------------------------------------------------------
#                  Mutation
# ------------------------------------------------------------------------
arr  =  lambda x: [x,x] if type(x)==int else list(x)

def fmt_arch(arch):
    assert set(arch.keys()) == {'Cseq','dseq'}
    assert len(arch['Cseq']) == (len(arch['dseq'])+1)
    return str({'Cseq': lmap(int,arch['Cseq']),
                'dseq': lmap(arr,list(arch['dseq'][:-1])+[arch['dseq'][-2]])})

def check_Cseq(Cseq):
    assert (Cseq[0]==Cseq[-1]==1) and all(map(lambda c: type(c)==int, Cseq))

def is_valid(arch):
    arch = eval(fmt_arch(arch))
    Cseq, dseq = arch['Cseq'], arch['dseq']
    def does_grow(d1,d2):
        geq  = lambda v1,v2: v1 in [v2, 2*v2]
        d1   = arr(d1)
        d2   = arr(d2)
        return (all(geq(x,y) for x,y in    [d1,d2]) and  # check          dilation in streamwise direction is larger (or equal)
                all(geq(b,a) for a,b in zip(d1,d2))   )  # check upcoming dilation                         is larger (or equal)
    check_Cseq(Cseq)
    assert  (len(Cseq)-1) == len(dseq)
    assert  Cseq[0] == Cseq[-1] == 1
    return all(does_grow(dseq[i],dseq[i+1]) for i in range(len(dseq)-1))


def mutate_d(dseq,Cseq):
    
    dseq = lmap(arr,dseq)
    
    def generic(dseq, f, get_prev):
        dseq = lmap(arr,dseq)
        A    = []
        prev = 1,1
        for d in dseq:
            A.append([f(x,p) for x,p in zip(arr(d),arr(prev))])
            prev = get_prev(d,A[-1])
        return A
    
    convert_dseq = lambda dseq: generic(dseq, lambda x,p: x//p, lambda d,last: d )
    rebuild      = lambda dseq: generic(dseq, lambda x,p: x*p , lambda d,last: last)
    assert rebuild(convert_dseq(dseq)) == dseq
    
    dseq   = convert_dseq(dseq)
    result = []
    for i in range(len(dseq)):
        
        prev_now_after  =  lambda A: [A[:i], A[i], A[(i+1):]]
        
        if  prev_now_after(dseq)[-1]:
            # after[0] exists
            def apply_flip():
                # basic flip
                reorder             =  lambda prev,now,after: prev + [after[0],now] + after[1:]
                
                # get values of C
                _, now_C, after_C  =  prev_now_after(Cseq)
                
                # define new sequences (respecting boundaries)
                if 1 in [now_C, after_C[0]]:
                    # applying "Cseq" twice is ok, it will be filtered by the "record" function
                    all_Cseq = [Cseq, Cseq]
                else:
                    all_Cseq = [Cseq, reorder(*prev_now_after(Cseq))]
                
                for CC in all_Cseq:
                    result.append(eval(fmt_arch({'dseq': rebuild(reorder(*prev_now_after(dseq))),
                                                 'Cseq': CC                                     })))
                    assert is_valid(result[-1])
            apply_flip()
        
        for new in [lambda now,m: {'d': []           , 'C': []       }[m],
                    lambda now,m: {'d': [1]          , 'C': [now]    }[m],
                    lambda now,m: {'d': [(2,1)]      , 'C': [now]    }[m],
                    lambda now,m: {'d': [2]          , 'C': [now]    }[m],
                    lambda now,m: {'d': [now  ,1    ], 'C': [now,now]}[m],
                    lambda now,m: {'d': [1    ,now  ], 'C': [now,now]}[m],
                    lambda now,m: {'d': [now  ,(2,1)], 'C': [now,now]}[m],
                    lambda now,m: {'d': [(2,1),now  ], 'C': [now,now]}[m],
                    lambda now,m: {'d': [now  ,2    ], 'C': [now,now]}[m],
                    lambda now,m: {'d': [2    ,now  ], 'C': [now,now]}[m]]:
            
            reorder = lambda prev, now, after, m: prev + new(now, m) + after
            CC      = reorder(*prev_now_after(Cseq),'C')
            CC      = [1] + CC[1:-1] + [1]
            if CC[ 1] == 1: CC = [1,CC[2]] + CC[2:  ]
            if CC[-2] == 1: CC =             CC[ :-2] + [CC[-3],1]
            result.append(eval(fmt_arch({'dseq': rebuild(reorder(*prev_now_after(dseq),'d')),
                                         'Cseq': CC                                         })))
            check_Cseq(CC)
            if not is_valid(result[-1]):
                result.pop()
    return result

mutate_d_empty  = lambda _,__: []

def mutate_c(Cseq):
    check_Cseq(Cseq)
    result = []
    for delta in [-1,1]:
        for i in range(1,len(Cseq)-1):
            result.append(Cseq[:i] + [Cseq[i]+delta] + Cseq[(i+1):])
            check_Cseq(result[-1]) 
    return result
    
def mutate_c_flat(Cseq):
    check_Cseq(Cseq)
    C_int   =  Cseq[1:-1]
    L_int   =  len(C_int)
    C_int,  =  list(set(C_int))
    result  =  []
    for delta in [-1,1]:
        result.append([Cseq[0]] + [(C_int+delta) for _ in range(L_int)] + [Cseq[-1]])
        check_Cseq(result[-1]) 
    return result

def ok_first_dseq(arch):
    return arr(arch['dseq'][0]) in [arr(1),arr(2),arr((2,1)),arr((1,2))]

def mk_mutations(best_arch, avoid, fmut_d = None, fmut_c = None):
    
    result  =  []
    avoid   =  set(lmap(fmt_arch, avoid))

    def record(new_arch):
        new_arch = eval(fmt_arch(new_arch))
        assert is_valid(new_arch)
        if not (fmt_arch(new_arch) in avoid):
            if ok_first_dseq(new_arch):
                avoid.add(fmt_arch(new_arch))
                result.append(new_arch)
    
    record(best_arch)
    lmap(record,starting_archs())
    if result:
        return result
    
    assert is_valid(best_arch)
    Cseq    =  lmap(int, best_arch['Cseq'])
    dseq    =  lmap(arr, best_arch['dseq'])
    
    check_Cseq(Cseq)
    
    def add_d():
        for new_arch in fmut_d(dseq,Cseq):
            record(new_arch)
    
    def add_c():
        for new_Cseq in fmut_c(Cseq):
            record({'Cseq': new_Cseq ,
                    'dseq': dseq     })
    
    add_d()
    add_c()
    random.shuffle(result)
    return result

# ------------------------------------------------------------------------
#                  Main Runner
# ------------------------------------------------------------------------

def main_runner(qmode, run_tag, device, ia_ib, epochs_avg, metric_names, phase, recursion_level):
    print(f'Host       : "{own_host}"')
    fmut_d = {'Phase_1': mutate_d       ,
              'Phase_2': mutate_d_empty }[phase]
    
    fmut_c = {'Phase_1': mutate_c_flat,
              'Phase_2': mutate_c     }[phase]
    
    line = '------------------------------------'
    if 'linux' in sys_platform:
        python_path  =  'python'
    else:
        python_path  =  f'{pjoin(get_folder_user()  , "anaconda3", "Scripts", "activate.bat")} && python'
    cache_abspath    =  pjoin(get_folder_cloud()        ,   'clean_cache.py')
    job_scheduler    =  pjoin(dirname(abspath(__file__)), 'job_scheduler.py')
    
    while True:
        if initial_code != own_code():
            if recursion_level <= 20:
                print('Code Change Detected, Running New Code')
                os_system(f"{python_path} {abspath(__file__)} {' '.join(argv[1:4])} {tag_reclvl}{recursion_level+1}")
            else:
                raise Exception('Code Change Detected, Recursion Level Exceeded')
            return
        if any(map(lambda x: own_host in x, reader(pjoin(dirname(abspath(__file__)),'host_end.dat')))): break
        existing_archs      =  Scan_Folder('ini', qmode).all_archs()
        scan_end            =  Scan_Folder('end', qmode, epochs_avg = int(epochs_avg), metric_names = metric_names)
        best_arch           =  scan_end.get_best_arch()
        all_mutation        =  mk_mutations(best_arch                ,
                                            avoid   =  existing_archs,
                                            fmut_d  =  fmut_d        ,
                                            fmut_c  =  fmut_c        )
        
        print('best_arch       :', best_arch)
        print('Number mutations:', len(all_mutation))
        print('Avg. Running Time:', scan_end.get_avg_running_time())
        
        print(f'\n\n{line}\nFull Set Mutations (Execution Order):\n{line}')
        print(all_mutation)
        if not all_mutation: break
        
        mutation = all_mutation[0]
        print('\n\nRunning Mutation:', mutation)
        os_system(f'{python_path} {cache_abspath}')
        os_system(f"{python_path} {job_scheduler} {qmode} {run_tag} {device} {ia_ib} Cseq_{fmt_str(mutation['Cseq'])} dseq_{fmt_str(mutation['dseq'])}")
        os_system(f'{python_path} {cache_abspath}')

# ------------------------------------------------------------------------
#                  Main Runner
# ------------------------------------------------------------------------

if __name__ == '__main__':
    if len(argv) == 4:
        qmode, device, phase  =  argv[1:]
        recursion_level       = 1
    else:
        qmode, device, phase, recursion_level  =  argv[1:]
        assert recursion_level.count(tag_reclvl) == 1
        recursion_level = int(recursion_level.replace(tag_reclvl,''))
    
    run_tag, ia_ib, epochs_avg, metric_names = 'n24comb', '0_0', '250', [['absdiff_abstotal',lambda e: 1.],['diff_total',lambda e: 3.]]
    main_runner(qmode, run_tag, device, ia_ib, epochs_avg, metric_names, phase, recursion_level)